﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class OrcaController : MonoBehaviour 
{
    public float jumpSpeed = 50f;
    public float moveSpeed = 10f;
    public float waveSpeed = 10f;

    private bool isFacingUp;
    private bool isFacingDown;

    private Transform from;
    public Transform up;
    public Transform down;
    public float negYBoundry = -2;
    public float yBoundry = 2;

    private Vector3 _newPosition;
    private bool doesMoveRight;
    private bool canTurn;
    private int horizontalAxis;

    public GameObject sonarSignal;
    public GameObject canvas;

    static public float waveAxisFrequency;
    public FacingDirection facingDirection;
    public GameObject whale;

    public enum FacingDirection
    {
        Right = 0,
        Front = 1,
        Left = 2,
        Back = 3
    }

	// Use this for initialization
	void Start () 
    {
        canvas.SetActive(false);
        from = transform;// new Vector3(0.0f, 0.0f, 0.0f);
        
        this.gameObject.GetComponent<Rigidbody>().velocity 
            = new Vector3(moveSpeed, gameObject.GetComponent<Rigidbody>().velocity.y, gameObject.GetComponent<Rigidbody>().velocity.z);

        doesMoveRight = true;
        canTurn = true;

        facingDirection = FacingDirection.Right;
	}
	
	// Update is called once per frame
	void Update () 
    {
        SinusMovement();

        if(doesMoveRight)
        {
            if (Input.GetAxis("Vertical") > 0.0f)// (Input.GetKeyDown(KeyCode.W) || Input.GetKeyDown(KeyCode.UpArrow)))
            {
                MoveUp();
            }

            if (Input.GetAxis("Vertical") < 0.0f)// ((Input.GetKeyDown(KeyCode.S) || Input.GetKeyDown(KeyCode.DownArrow)))
            {
                MoveDown();
            }
            // Right -> Back, Front
            if (facingDirection == FacingDirection.Right && Input.GetAxis("Horizontal") > 0 && canTurn)
            {
                canTurn = false;
                StartCoroutine(TurnRight()); 
                
            }
            else if (facingDirection == FacingDirection.Right && Input.GetAxis("Horizontal") < 0 && canTurn)
            {
                canTurn = false;
                StartCoroutine(TurnLeft()); 
            }

            if (facingDirection == FacingDirection.Back && Input.GetAxis("Horizontal") > 0 && canTurn)
            {
                canTurn = false;
                StartCoroutine(TurnRight()); 

            }
            else if (facingDirection == FacingDirection.Back && Input.GetAxis("Horizontal") < 0 && canTurn)
            {
                canTurn = false;
                StartCoroutine(TurnLeft());
            }

            if (facingDirection == FacingDirection.Left && Input.GetAxis("Horizontal") > 0 && canTurn)
            {
                canTurn = false;
                StartCoroutine(TurnRight());

            }
            else if (facingDirection == FacingDirection.Left && Input.GetAxis("Horizontal") < 0 && canTurn)
            {
                canTurn = false;
                StartCoroutine(TurnLeft());
            }

            if (facingDirection == FacingDirection.Front && Input.GetAxis("Horizontal") > 0 && canTurn)
            {
                canTurn = false;
                StartCoroutine(TurnRight());

            }
            else if (facingDirection == FacingDirection.Front && Input.GetAxis("Horizontal") < 0 && canTurn)
            {
                canTurn = false;
                StartCoroutine(TurnLeft());
            }

            // Back -> Right, Left
            /*else if (Input.GetAxis("Horizontal") > 0 && facingDirection == FacingDirection.Back)
            {
                StartCoroutine(TurnRight());

            }
            else if (Input.GetAxis("Horizontal") < 0 && facingDirection == FacingDirection.Back)
            {
                StartCoroutine(TurnLeft());
            }*/

            if(Input.GetKeyDown(KeyCode.Space))
            {
                FireSonar();
            }
        }
        //transform.rotation = Quaternion.Lerp(from.rotation, up.rotation, Time.time * 0.1f);

        //gameObject.GetComponent<Rigidbody>().AddForce(transform.forward * moveSpeed, ForceMode.Acceleration);
        
        /*if ((Input.GetKeyDown(KeyCode.W) || Input.GetKeyDown(KeyCode.UpArrow)))
        {
            transform.Rotate(Vector3.up * 5 * Time.deltaTime);
            transform.rotation = Quaternion.Lerp(from.rotation, up.rotation, Time.time * 0.1f);
            //transform.Rotate(45.0f, transform.rotation.y, transform.rotation.z);
            
            //gameObject.GetComponent<Rigidbody>().AddForce(transform.forward * moveSpeed, ForceMode.Acceleration);// new Vector3(transform.forward * moveSpeed, jumpSpeed, 0.0f));
                
            // velocity = new Vector3(moveSpeed, jumpSpeed, gameObject.GetComponent<Rigidbody>().velocity.z);
        }

        if ((Input.GetKeyDown(KeyCode.S) || Input.GetKeyDown(KeyCode.DownArrow)))
        {
            transform.rotation = Quaternion.Lerp(from.rotation, down.rotation, Time.time * 0.1f);
            //transform.Rotate(45.0f, transform.rotation.y, transform.rotation.z);

            //gameObject.GetComponent<Rigidbody>().AddForce(transform.forward * moveSpeed, ForceMode.Acceleration);// new Vector3(transform.forward * moveSpeed, jumpSpeed, 0.0f));

            // velocity = new Vector3(moveSpeed, jumpSpeed, gameObject.GetComponent<Rigidbody>().velocity.z);
        }

        if ((Input.GetKeyDown(KeyCode.A) || Input.GetKeyDown(KeyCode.LeftArrow)))
        {
            gameObject.GetComponent<Rigidbody>().AddForce(-transform.forward * moveSpeed, ForceMode.Acceleration); //new Vector3(-moveSpeed, jumpSpeed, 0.0f));

            // velocity = new Vector3(moveSpeed, jumpSpeed, gameObject.GetComponent<Rigidbody>().velocity.z);
        }

        if((Input.GetKeyDown(KeyCode.D) && (Input.GetKeyDown(KeyCode.S) || Input.GetKeyDown(KeyCode.LeftArrow))))
        {
            transform.Rotate(transform.rotation.x * 45.0f, transform.rotation.y, transform.rotation.z);
        }*/
	}

    private IEnumerator TurnLeft()
    {
        facingDirection = RotateDirectionLeft();

        transform.Rotate(new Vector3(0.0f, -90.0f, 0.0f));

        if (facingDirection == FacingDirection.Back)
        {
            this.gameObject.GetComponent<Rigidbody>().velocity
                = new Vector3(0.0f, gameObject.GetComponent<Rigidbody>().velocity.y, moveSpeed);
        }
        else if (facingDirection == FacingDirection.Left)
        {
            
            this.gameObject.GetComponent<Rigidbody>().velocity
                = new Vector3(-moveSpeed, gameObject.GetComponent<Rigidbody>().velocity.y, 0);
        }
        else if (facingDirection == FacingDirection.Front)
        {
            
            this.gameObject.GetComponent<Rigidbody>().velocity
                = new Vector3(0.0f, gameObject.GetComponent<Rigidbody>().velocity.y, -moveSpeed);
        }
        else if (facingDirection == FacingDirection.Right)
        {
            
            this.gameObject.GetComponent<Rigidbody>().velocity
                = new Vector3(moveSpeed, gameObject.GetComponent<Rigidbody>().velocity.y, 0.0f);
        }

        yield return new WaitForSeconds(1.0f);
        //Waiter();

        canTurn = true;
    }

    private IEnumerator TurnRight()
    {
        facingDirection = RotateDirectionRight();
        
        transform.Rotate(new Vector3(0.0f, 90.0f, 0.0f));

        if (facingDirection == FacingDirection.Front)
        {
            this.gameObject.GetComponent<Rigidbody>().velocity
                = new Vector3(0.0f, gameObject.GetComponent<Rigidbody>().velocity.y, -moveSpeed);
        }
        else if (facingDirection == FacingDirection.Left)
        {
            this.gameObject.GetComponent<Rigidbody>().velocity
                = new Vector3(-moveSpeed, gameObject.GetComponent<Rigidbody>().velocity.y, 0);
            AnimController.states = AnimationStates.idle;
        }
        else if (facingDirection == FacingDirection.Back)
        {
            this.gameObject.GetComponent<Rigidbody>().velocity
                = new Vector3(0.0f, gameObject.GetComponent<Rigidbody>().velocity.y, moveSpeed);
        }
        else if (facingDirection == FacingDirection.Right)
        {
            this.gameObject.GetComponent<Rigidbody>().velocity
                = new Vector3(moveSpeed, gameObject.GetComponent<Rigidbody>().velocity.y, 0);
            AnimController.states = AnimationStates.idle;
        }
        else if (facingDirection == FacingDirection.Front)
        {
            this.gameObject.GetComponent<Rigidbody>().velocity
                = new Vector3(0.0f, gameObject.GetComponent<Rigidbody>().velocity.y, -moveSpeed);
        }
        else if (facingDirection == FacingDirection.Right)
        {
            this.gameObject.GetComponent<Rigidbody>().velocity
                = new Vector3(moveSpeed, gameObject.GetComponent<Rigidbody>().velocity.y, 0.0f);
            AnimController.states = AnimationStates.idle;
        }

        yield return new WaitForSeconds(1.0f);
        //Waiter();

        canTurn = true;
    }

    private void FireSonar()
    {
        if (facingDirection == FacingDirection.Right)
        {
            GameObject signal =
                Instantiate(sonarSignal, this.gameObject.transform.position + new Vector3(20.0f, 0.0f, 0.0f), Quaternion.identity)
                as GameObject;
            signal.GetComponent<Rigidbody>().velocity
             = new Vector3(50.0f, gameObject.GetComponent<Rigidbody>().velocity.y, gameObject.GetComponent<Rigidbody>().velocity.z); 

        }
        else if (facingDirection == FacingDirection.Back)
        {
            GameObject signal =
                Instantiate(sonarSignal, this.gameObject.transform.position + new Vector3(0.0f, 0.0f, 20.0f), Quaternion.identity) as GameObject;
            signal.transform.Rotate(90.0f, 270.0f, 0.0f);
            signal.GetComponent<Rigidbody>().velocity
             = new Vector3(gameObject.GetComponent<Rigidbody>().velocity.x, gameObject.GetComponent<Rigidbody>().velocity.y, 50.0f); 
        }
        else if (facingDirection == FacingDirection.Left)
        {
            GameObject signal =
                Instantiate(sonarSignal, this.gameObject.transform.position + new Vector3(-20.0f, 0.0f, 0.0f), Quaternion.identity) as GameObject;
            signal.transform.Rotate(0.0f, 180.0f, 0.0f);
            signal.GetComponent<Rigidbody>().velocity
             = new Vector3(-50.0f, gameObject.GetComponent<Rigidbody>().velocity.y, gameObject.GetComponent<Rigidbody>().velocity.z); 
        }
        else if (facingDirection == FacingDirection.Front)
        {
            GameObject signal =
                Instantiate(sonarSignal, this.gameObject.transform.position + new Vector3(0.0f, 0.0f, -20.0f), Quaternion.identity) as GameObject;
            signal.transform.Rotate(90.0f, 90.0f, 0.0f);
            signal.GetComponent<Rigidbody>().velocity
             = new Vector3(gameObject.GetComponent<Rigidbody>().velocity.x, gameObject.GetComponent<Rigidbody>().velocity.y, -50.0f); 
        }

        AnimController.states = AnimationStates.fire;
  
    }

    private void MoveDown()
    {
        transform.position = new Vector3(transform.position.x, transform.position.y - 1.0f, transform.position.z);
        if (transform.position.y < negYBoundry)
            transform.position = new Vector3(transform.position.x, negYBoundry, transform.position.z);
        AnimController.states = AnimationStates.idle;
    }

    private void MoveUp()
    {
        transform.position = new Vector3(transform.position.x, transform.position.y + 1.0f, transform.position.z);
        if (transform.position.y > yBoundry)
            transform.position = new Vector3(transform.position.x, yBoundry, transform.position.z);
        AnimController.states = AnimationStates.idle;
    }

    private void SinusMovement()
    {
        _newPosition = transform.position;
        _newPosition.y += 2 * Mathf.Sin(Time.time) * Time.deltaTime;
        waveAxisFrequency += 2 * Mathf.Sin(Time.time) * Time.deltaTime * waveSpeed;
        transform.position = _newPosition;
    }

    private FacingDirection RotateDirectionRight()
    {
        int change = (int)(facingDirection);
        change++;
        //Our FacingDirection enum only has 4 states, if we go past the last state, loop to the first
        if (change > 3)
            change = 0;
        return (FacingDirection)(change);
    }
    /// <summary>
    /// Determines the facing direction after we rotate to the left
    /// </summary>
    /// <returns>The direction left.</returns>
    private FacingDirection RotateDirectionLeft()
    {
        int change = (int)(facingDirection);
        change--;
        //Our FacingDirection enum only has 4 states, if we go below the first, go to the last state
        if (change < 0)
            change = 3;
        return (FacingDirection)(change);
    }


    void OnTriggerEnter(Collider col)
    {
        Debug.Log("We in");
        if (col.GetComponent<JellyFish>().type == JellyTypes.blue)  
        {
            Debug.Log("inside of if");
            Shrink(col.gameObject);
        }

        if (col.GetComponent<JellyFish>().type == JellyTypes.green)
        {
            Grow(col.gameObject);
        }

        if (col.GetComponent<JellyFish>().type == JellyTypes.red)
        {
            Dead(col.gameObject);  
        }

    }

    void Grow(GameObject go)
    {
        if(this.transform.localScale.x < 525 )
            this.transform.localScale  /*+= new Vector3(1, 1, 1) * 0.5f;*/ = Vector3.Lerp(this.transform.localScale, this.transform.localScale += new Vector3(500, 500, 500) * 0.5f , 5*Time.deltaTime);
    }

    void Shrink(GameObject go)
    {
        if (this.transform.localScale.x > 525)
            this.transform.localScale /* -= new Vector3(1,1,1) * 0.5f;*/= Vector3.Lerp(this.transform.localScale, this.transform.localScale += new Vector3(500, 500, 500) * 0.5f, 5*Time.deltaTime);
    }

    void Dead(GameObject go)
    {
        Debug.Log("öl lan");
        canvas.SetActive(true); 
        
        //whale.transform.rotation = new Quaternion(180, transform.rotation.y, transform.rotation.z,transform.rotation.w);
        Time.timeScale = 0;
    }

    public void TryAgain()
    {
        Time.timeScale = 1;
        Application.LoadLevel(Application.loadedLevel);
    }

}
